yl_speak_up = {}

local modpath = minetest.get_modpath("yl_speak_up")..DIR_DELIM
yl_speak_up.worldpath = minetest.get_worldpath()..DIR_DELIM
yl_speak_up.modpath = modpath

yl_speak_up.modstorage = minetest.get_mod_storage()

-- status
-- 0: NPCs may speak
-- 1: NPCs may not speak
-- 2: NPCs must selfdestruct on load. Their dialogs remain safed

yl_speak_up.status = yl_speak_up.modstorage:get_int("status") or 0
yl_speak_up.number_of_npcs = yl_speak_up.modstorage:get_int("amount") or 0
yl_speak_up.speak_to = {}

dofile(modpath .. "config.lua")
dofile(modpath .. "privs.lua")
-- handle on_player_receive_fields and showing of formspecs
dofile(modpath .. "show_fs.lua")
-- edit preconditions (can be reached through edit options dialog)
dofile(modpath .. "fs_edit_preconditions.lua")
-- edit effects (can be reached through edit options dialog)
dofile(modpath .. "fs_edit_effects.lua")
-- edit options dialog (detailed configuration of options in edit mode)
dofile(modpath .. "fs_edit_options_dialog.lua")
-- set name, description and owner (owner only with npc_talk_master priv)
dofile(modpath .. "fs_initial_config.lua")
-- inventory management, trading and handling of quest items:
dofile(modpath .. "inventory.lua")
-- trade one item(stack) against one other item(stack)
dofile(modpath .. "trade_simple.lua")
-- easily accessible list of all trades the NPC offers
dofile(modpath .. "trade_list.lua")
-- the main functionality of the mod
dofile(modpath .. "functions.lua")
-- the staffs (requires npc_master priv)
dofile(modpath .. "tools.lua")
-- the actual mobs, using mobs_redo
dofile(modpath .. "mobs.lua")
--dofile(modpath .. "debug.lua")

minetest.mkdir(yl_speak_up.worldpath..yl_speak_up.path)
minetest.mkdir(yl_speak_up.worldpath..yl_speak_up.inventory_path)

yl_speak_up.mob_table = yl_speak_up.init_mob_table() or {}

minetest.log("action","[MOD] yl_speak_up loaded")
